#
# Copyright (c) 2024, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Optional, Union


class Context:
    """
    Container for step context, it can contain text or data table.
    """

    def __init__(self) -> None:
        self.text: Optional[str] = None
        self.table: Optional[Union["DataGenerator", "PythonDataGenerator"]] = None  # type: ignore  # noqa: F821

    def set_text(self, text: str) -> None:
        self.text = text

    def set_table(self, table: Union["DataGenerator", "PythonDataGenerator"]) -> None:  # type: ignore  # noqa: F821
        self.table = table
