#
# Copyright (c) 2024, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Generator, Dict, List


class DataTable:
    def __init__(self) -> None:
        self.headers: List[str] = []
        self.lines: List[List[str]] = []

    def set_headers(self, placeholders: List[str]) -> None:
        self.headers = placeholders

    def add_line(self, data_line: List[str]) -> None:
        assert self.headers, "headers are not set"
        assert len(self.headers) == len(data_line), "headers and lines must have the same length"
        self.lines.append(data_line)

    def __iter__(self) -> Generator[Dict[str, str], None, None]:
        for line in self.lines:
            yield dict(zip(self.headers, line))
