#
# Copyright (c) 2024, HILSTER - https://hilster.io
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from typing import Union

from htf.core import Author as _Author
from htf.core import Date as _Date
from htf.core import HeadURL as _HeadURL
from htf.core import Header as _Header
from htf.core import Id as _Id
from htf.core import KeywordsMetaData as _KeywordsMetaData
from htf.core import LastChangedBy as _LastChangedBy
from htf.core import LastChangedDate as _LastChangedDate
from htf.core import LastChangedRevision as _LastChangedRevision
from htf.core import MetaData as _MetaData
from htf.core import RCSFile as _RCSFile
from htf.core import RCSfile as _RCSfile
from htf.core import Rev as _Rev
from htf.core import Revision as _Revision
from htf.core import Source as _Source
from htf.core import TestingframeworkVersion as _TestingframeworkVersion
from htf.core import URL as _URL


class Author(_Author):
    """
    Returns "an author" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Author, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Author, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Author, self).set(value=value)


class Date(_Date):
    """
    Returns "a date" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Date, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Date, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Date, self).set(value=value)


class HeadURL(_HeadURL):
    """
    Returns: "https://server:port:/file" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(HeadURL, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(HeadURL, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(HeadURL, self).set(value=value)


class Header(_Header):
    """
    Returns "a header" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Header, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Header, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Header, self).set(value=value)


class Id(_Id):
    """
    Returns "an id" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Id, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Id, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Id, self).set(value=value)


class KeywordsMetaData(_KeywordsMetaData):
    """
    ``MetaData`` can be used to mark variables to be handled as meta data.

    For example ``MetaData`` can be used to set additional attributes of a
    test case that is put into the meta data section of a test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(KeywordsMetaData, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(KeywordsMetaData, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(KeywordsMetaData, self).set(value=value)


class LastChangedBy(_LastChangedBy):
    """
    Returns the author of the last modification of the document.

    Alias of :class:`Author <htf.Author>`.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(LastChangedBy, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(LastChangedBy, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(LastChangedBy, self).set(value=value)


class LastChangedDate(_LastChangedDate):
    """
    Returns "a date" in test report.

    Alias of :class:`Date <htf.Date>`.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(LastChangedDate, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(LastChangedDate, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(LastChangedDate, self).set(value=value)


class LastChangedRevision(_LastChangedRevision):
    """
    Returns "a revision" in test report.

    Alias of :class:`Revision <htf.Revision>`.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(LastChangedRevision, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(LastChangedRevision, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(LastChangedRevision, self).set(value=value)


class MetaData(_MetaData):
    """
    ``MetaData`` can be used to mark variables to be handled as meta data.

    For example ``MetaData`` can be used to set additional attributes of a
    test case that is put into the meta data section of a test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(MetaData, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(MetaData, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(MetaData, self).set(value=value)


class RCSFile(_RCSFile):
    """
    Returns: RCSFile marker
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(RCSFile, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(RCSFile, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(RCSFile, self).set(value=value)


class RCSfile(_RCSfile):
    """
    Returns: RCSfile marker

    Alias of :class:`RCSFile <htf.RCSFile>`.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(RCSfile, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(RCSfile, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(RCSfile, self).set(value=value)


class Rev(_Rev):
    """
    Returns "a revision" in test report.

    Alias of :class:`Revision <htf.Revision>`.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Rev, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Rev, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Rev, self).set(value=value)


class Revision(_Revision):
    """
    Returns "a revision" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Revision, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Revision, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Revision, self).set(value=value)


class Source(_Source):
    """
    Returns: "a source file" in test report.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(Source, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(Source, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(Source, self).set(value=value)


class TestingframeworkVersion(_TestingframeworkVersion):
    """
    Returns: "htf-<htf-version> on Python <python-version>" in test report.
    """

    def __init__(self) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(TestingframeworkVersion, self).__init__()

    def get(self) -> Union[str, bytes]:
        return super(TestingframeworkVersion, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(TestingframeworkVersion, self).set(value=value)


class URL(_URL):
    """
    Returns: "https://server:port:/file" in test report.

    Alias of :class:`HeadURL <htf.HeadURL>`.
    """

    def __init__(self, value: Union[str, bytes]) -> None:
        """
        Initialize self.  See help(type(self)) for accurate signature.
        """
        super(URL, self).__init__(value=value)

    def get(self) -> Union[str, bytes]:
        return super(URL, self).get()

    def set(self, value: Union[str, bytes]) -> None:
        return super(URL, self).set(value=value)
